> For the complete documentation index, see [llms.txt](https://docs.yemreak.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yemreak.com/arsiv/kotlin/fonksiyonlar.md).

# Fonksiyonlar

## ➕ Function Extension

* ➕ Olmayan metotları sınıflara sonradan dahil edebilirsiniz
* 💁‍♂️ Tanımlı olan sınıflara `.` operatörü ile metotlar ekleyebilirsiniz
* 🐥 Metot yerine `get() =` yapısı ile property (özellik) de eklenebilir
* 👇 Alttaki örneklerde `Uri` ve `WifiP2pInfo` sınıfına metodu ve özellik ekliyoruz

![](https://2136337814-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F3IVBqG9Jn8K2viWOpgUm%2Fuploads%2Fgit-blob-96d8bd3df0cd888793aefbb45ef2ab8ab08f526d%2Fkotlin_function_extension.png?alt=media)

```kotlin
// Metot genişletmeleri
fun Uri.getInputStream(activity: Activity): InputStream {
    return activity.contentResolver.openInputStream(this)!!
}

val activity = Activity()
val mUri: Uri = new Uri()

// Kullanım
val inputStream = uri.inputStream(activity)
```

```kotlin
// Özellik genişletmeleri
val WifiP2pInfo.isConnected: Boolean
    get() = groupFormed

val WifiP2pInfo.isClient: Boolean
    get() = isConnected && !isGroupOwner

val WifiP2pInfo.isServer: Boolean
    get() = isConnected && isGroupOwner
    
val info: WifiP2pInfo = WifiP2pInfo()

// Kullanımlar
info.isConnected
info.isClient
info.isServer
```

{% hint style="warning" %}
📢 `Uri` ve `WifiP2pInfo` sınıfı temel java sınıflarından birisidir
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.yemreak.com/arsiv/kotlin/fonksiyonlar.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
